# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}

%define section free

Name:           xmlrpc
Version:        3.0
Release:        1jpp
Epoch:          0
Summary:        Java XML-RPC implementation
License:        Apache Software License
Group:          Development/Java
Url:            http://ws.apache.org/xmlrpc/
Source0:        http://www.apache.org/dist/ws/xmlrpc/sources/xmlrpc-3.0-src.tar.gz
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        %{name}-build.xml
Source4:        %{name}-client-build.xml
Source5:        %{name}-common-build.xml
Source6:        %{name}-server-build.xml
Source7:        %{name}-tests-build.xml

Patch0:         xmlrpc-pom_xml.patch
Patch1:         xmlrpc-tests-pom_xml.patch
Patch2:         xmlrpc-site_xml.patch

BuildRequires:  jpackage-utils >= 0:1.7.2
BuildRequires:  ant
BuildRequires:  junit
BuildRequires:  jakarta-commons-codec
BuildRequires:  jakarta-commons-httpclient
BuildRequires:  jakarta-commons-logging
BuildRequires:  servletapi5
BuildRequires:  ws-commons-java5
BuildRequires:  ws-commons-util
BuildRequires:  ws-jaxme
BuildRequires:  xml-commons-jaxp-1.3-apis

%if %{with_maven}
BuildRequires:  maven2 >= 2.0.4-10jpp
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-surefire
%endif
Requires:  jakarta-commons-codec
Requires:  jakarta-commons-httpclient
Requires:  jakarta-commons-logging
Requires:  servletapi5
Requires:  ws-commons-java5
Requires:  ws-commons-util
Requires:  ws-jaxme
Requires:  xml-commons-jaxp-1.3-apis
%if ! %{gcj_support}
Buildarch:      noarch
%endif
Buildroot:      %{_tmppath}/%{name}-%{version}-buildroot
Vendor: %{?_vendorinfo:%{_vendorinfo}}%{!?_vendorinfo:%{_vendor}}
Distribution: %{?_distribution:%{_distribution}}%{!?_distribution:%{_vendor}}
Requires(post):    jpackage-utils >= 0:1.7.2
Requires(postun):  jpackage-utils >= 0:1.7.2
%if %{gcj_support}
BuildRequires:    gnu-crypto
BuildRequires:    java-gcj-compat-devel
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif

%description
Apache XML-RPC is a Java implementation of XML-RPC, a popular protocol
that uses XML over HTTP to implement remote procedure calls.
Apache XML-RPC was previously known as Helma XML-RPC. If you have code
using the Helma library, all you should have to do is change the import
statements in your code from helma.xmlrpc.* to org.apache.xmlrpc.*.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires(post): %{__rm}
Requires(postun): %{__rm}
Requires(post): /bin/ln

%description javadoc
%{summary}.

%if %{with_maven}
%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.
%endif

%prep
%setup -q -n %{name}-%{version}
find . -depth -name .svn -exec rm -rf {} \;
cp %{SOURCE1} settings.xml
cp %{SOURCE3} build.xml
cp %{SOURCE4} client/build.xml
cp %{SOURCE5} common/build.xml
cp %{SOURCE6} server/build.xml
cp %{SOURCE7} tests/build.xml
# remove all binary libs
find . -name "*.jar" -exec rm -f {} \;
%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav

%build
%if %{with_maven}
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

mkdir common/src/site
cp src/site/site.xml common/src/site
mkdir client/src/site
cp src/site/site.xml client/src/site
mkdir server/src/site
cp src/site/site.xml server/src/site
mkdir tests/src/site
cp src/site/site.xml tests/src/site
mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        -Dmaven2.jpp.mode=true \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        install javadoc:javadoc site:site

%else
pushd common
export CLASSPATH=$(build-classpath ws-commons-java5 ws-commons-util jaxme/jaxmeapi xml-commons-jaxp-1.3-apis)
ant -Dbuild.sysclasspath=only jar javadoc
popd

pushd client
export CLASSPATH=$(build-classpath ws-commons-java5 ws-commons-util commons-httpclient xml-commons-jaxp-1.3-apis)
CLASSPATH=$CLASSPATH:../common/target/%{name}-common-%{version}.jar
ant -Dbuild.sysclasspath=only jar javadoc
popd

pushd server
export CLASSPATH=$(build-classpath commons-logging ws-commons-java5 ws-commons-util servletapi5 xml-commons-jaxp-1.3-apis)
CLASSPATH=$CLASSPATH:../common/target/%{name}-common-%{version}.jar
ant -Dbuild.sysclasspath=only jar javadoc
popd

pushd tests
export CLASSPATH=$(build-classpath commons-logging commons-codec commons-httpclient ws-commons-util servletapi5 xml-commons-jaxp-1.3-apis)
CLASSPATH=$CLASSPATH:../common/target/%{name}-common-%{version}.jar
CLASSPATH=$CLASSPATH:../client/target/%{name}-client-%{version}.jar
CLASSPATH=$CLASSPATH:../server/target/%{name}-server-%{version}.jar
CLASSPATH=$CLASSPATH:target/test-classes
ant -Dbuild.sysclasspath=only jar javadoc
popd

%endif
mkdir temp
pushd temp
jar xf ../server/target/%{name}-server-%{version}.jar
jar xf ../client/target/%{name}-client-%{version}.jar
jar xf ../common/target/%{name}-common-%{version}.jar
sed -i -e "s|-common||g" META-INF/MANIFEST.MF
jar cmf META-INF/MANIFEST.MF ../%{name}-%{version}.jar *
popd

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 %{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 common/target/%{name}-common-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/common-%{version}.jar
install -m 644 client/target/%{name}-client-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/client-%{version}.jar
install -m 644 server/target/%{name}-server-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/server-%{version}.jar
install -m 644 tests/target/%{name}-tests-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/tests-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do \
ln -sf ${jar} ${jar/-%{version}/}; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do \
ln -sf ${jar} ${jar/-%{version}/}; done)

%add_to_maven_depmap org.apache.xmlrpc xmlrpc %{version} JPP %{name}
%add_to_maven_depmap org.apache.xmlrpc xmlrpc-client %{version} JPP/%{name} client
%add_to_maven_depmap org.apache.xmlrpc xmlrpc-common %{version} JPP/%{name} common
%add_to_maven_depmap org.apache.xmlrpc xmlrpc-server %{version} JPP/%{name} server
%add_to_maven_depmap org.apache.xmlrpc xmlrpc-tests %{version} JPP/%{name} tests

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
install -m 644 client/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-client.pom
install -m 644 common/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-common.pom
install -m 644 server/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-server.pom
install -m 644 tests/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-tests.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%if %{with_maven}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%else
for m in common client server tests; do
    install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/$m
    cp -pr $m/target/site/apidocs/* \
                      $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/$m
done
%endif
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
install -m 644 LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
%if %{with_maven}
rm -rf target/site/apidocs
cp -pr target/site $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
%endif

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%dir %{_docdir}/%{name}-%{version}
%{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/%{name}*
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/*-%{version}.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%if %{with_maven}
%files manual
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}/site
%endif

%changelog
* Mon Aug 06 2007 Ralph Apel <r.apel at r-apel.de> - 0:3.0-1jpp
- Upgrade to 3.0
- Add poms and depmap frags
- Make Vendor, Distribution based on macro

* Fri Aug 04 2006 Vivek Lakshmanan <vivekl@redhat.com> - 0:2.0.1-3jpp
- Add conditional native compilation for GCJ.
- Add Requires(x) sections for -javadoc sub-package.

* Mon Apr 04 2006 Ralph Apel <r.apel@r-apel.de> - 0:2.0.1-2jpp
- Fix jakarta-commons requires naming

* Wed Jan 18 2006 Igor Foox <ifoox@rehdat.com> - 0:2.0.1-1jpp
- Update to version 2.0.1.

* Thu Jan 05 2006 Fernando Nasser <fnasser@redhat.com> 0:1.2-0.b1.4jpp
- First JPP 1.7 build

* Thu Aug 26 2004 Ralph Apel <r.apel at r-apel.de> 0:1.2-0.b1.3jpp
- Build with ant-1.6.2

* Thu Apr 29 2004 David Walluck <david@jpackage.org> 0:1.2-0.b1.2jpp
- add jar symlinks
- remove %%buildroot in %%install

* Tue May 06 2003 David Walluck <david@anti-microsoft.org> 0:1.2-0.b1.1jpp
- 1.2-b1
- update for JPackage 1.5

* Mon Mar 18 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.1-1jpp 
- 1.1
- generic servlet support
- used source release
- dropped patch
- added applet jar

* Mon Jan 21 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-3jpp 
- versioned dir for javadoc
- no dependencies for javadoc package
- dropped jsse package
- adaptation to new servlet3 package
- adaptation to new jsse package
- section macro

* Fri Dec 7 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-2jpp
- javadoc into javadoc package

* Sat Nov 3 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-1jpp
- first JPackage release
